package pl.smi.sms.active.ra.ejbc;

import pl.smi.sms.active.process.ActivityProcessableRemote;
import pl.smi.sms.active.ra.ActivityInitiator;
import pl.smi.sms.active.ra.JNDIActivityData;

public class EJBCActivityInitiator extends ActivityInitiator {

	private final JNDIActivityData connectionData;
	private ActivityProcessableRemote activity = null;

	public EJBCActivityInitiator(JNDIActivityData connectionData) {
		this.connectionData = connectionData;
	}

	public EJBCActivityInitiator(JNDIActivityData connectionData,
			ActivityProcessableRemote activity) {
		this.connectionData = connectionData;
		this.activity = activity;
	}
    
	public ActivityProcessableRemote getActivity() {
		return activity;
	}
	
//	public ActivityProcessableRemote lookupActivity()
//			throws ResourceAdapterInternalException {
//		ActivityProcessableRemote activity = null;
//		Logger.getLogger(this.getClass().getName()).info(
//				"====="+this.getClass().getClassLoader().hashCode());
//		try {
////			InitialContext ctx = new InitialContext();
////            java.util.Properties p = new java.util.Properties();
////            p.put("org.omg.CORBA.ORBInitialHost","localhost");
////            p.put("org.omg.CORBA.ORBInitialPort","3700");
//            InitialContext ctx = new javax.naming.InitialContext();
//			Logger.getLogger(this.getClass().getName()).info("lookupActivity start:");
//			
//			
//			DataSource ds  = (DataSource) new InitialContext()
//			.lookup(MappedNames.ACTIVE_DATASOURCE);
//			
//			Logger.getLogger(this.getClass().getName()).info("lookupActivity DataSource OK:");
//			 
//			
//			Object lookup = ctx.lookup(connectionData.getAddress());
//			Logger.getLogger(this.getClass().getName()).info("lookupActivity lookup:"+lookup.getClass().getName());
//			Logger.getLogger(this.getClass().getName()).info("lookupActivity interf:"+ActivityProcessableRemote.class.getName());
//			
//			
//			
//			
//			
//			activity = (ActivityProcessableRemote) lookup;
//		} catch (NamingException e) {
//			e.printStackTrace();
//			throw new ResourceAdapterInternalException(ErrorCode.ACT_ERR_0002
//					.getMessage()
//					+ " (name: " + connectionData.getAddress() + ")",
//					ErrorCode.ACT_ERR_0002.name());
//		}
//		Logger.getLogger(this.getClass().getName()).info("lookup OK!");
//		return activity;
//	}

//	@Override
//	public Status initActivity() {
//		if (activity == null) {
//			try {
//				activity = lookupActivity();
//			} catch (ResourceAdapterInternalException e) {
//				Logger.getLogger(this.getClass().getName()).warning(
//						"ResourceAdapterInternalException error code: "
//								+ e.getErrorCode() + " message: "
//								+ e.getMessage());
//				return Status.FAILED;
//			}
//		}
//
//		try {
//			activity.doInit();
//		} catch (Exception ex) {
//			EJBCCallExceptionHandler.logException(ex, " While doInit (EJBCActivityInitiator) of "+connectionData.getAddress(),this.getClass().getName());
//			return Status.FAILED;
//		}
//		return Status.ACTIVE;
//	}

}
