package pl.smi.sms.active.ra.ejbc;

import java.util.logging.Logger;

public class EJBCCallExceptionHandler {
	
	public static void logException(Exception ex,String sourceName,String loggerName) {
		
		if (ex instanceof javax.ejb.EJBException ) {
			Throwable getCause = ex.getCause();
			if (getCause != null) {
				// java.rmi.MarshalException
				Logger.getLogger(loggerName).warning(
						sourceName
								+ " EJBException coused by "
								+ getCause.getClass().getName());
			} else {
				Logger.getLogger(loggerName).warning(
						sourceName
								+ " EJBException coused by "
								+ ex.getClass().getName());
			}
			
		}
		else {
			Logger.getLogger(loggerName).warning(
					sourceName +" throw exception "+ ex.getClass().getName());			
		}
		
	}
	
}
