package pl.smi.sms.active.ra.ejbc;

import java.io.Serializable;
import java.util.logging.Logger;

import javax.resource.NotSupportedException;
import javax.resource.ResourceException;
import javax.resource.spi.ActivationSpec;
import javax.resource.spi.BootstrapContext;
import javax.resource.spi.ResourceAdapter;
import javax.resource.spi.ResourceAdapterInternalException;
import javax.resource.spi.endpoint.MessageEndpointFactory;
import javax.resource.spi.work.WorkManager;
import javax.transaction.xa.XAResource;

public class EJBCResourceAdapterImpl implements ResourceAdapter, Serializable {
	// private String activityCode, connectionData;
	// private int managerID;
	// ManagerID=1:Code=ActivityTest:ActivityData
	private WorkManager workManager;
	private BootstrapContext bootstrapContext;
//	private EJBCActivityConnectionStateManager connectionStateManager;
	
	

	public EJBCResourceAdapterImpl() {
		super();
		Logger.getLogger(this.getClass().getName()).info(
				"EJBCResourceAdapterImpl CONSTRUCTOR " +this.hashCode());
	}

	public void endpointActivation(MessageEndpointFactory arg0,
			ActivationSpec arg1) throws ResourceException {
		Logger.getLogger(this.getClass().getSimpleName()).info(
				"endpointActivation()");
		throw new NotSupportedException("Endpoint Activation not supported");

	}

	public void endpointDeactivation(MessageEndpointFactory arg0,
			ActivationSpec arg1) {
		Logger.getLogger(this.getClass().getName()).info(
				"endpointDeactivation()");

	}

	public XAResource[] getXAResources(ActivationSpec[] arg0)
			throws ResourceException {
		throw new NotSupportedException("XA recovery not supported"); // TODO XA
		// return null;
	}

//	public EJBCActivityConnectionStateManager getConnectionStateManager() {
//		return connectionStateManager;
//	}

	public void start(BootstrapContext bootstrapContext)
			throws ResourceAdapterInternalException {
		Logger.getLogger(this.getClass().getName()).info(
				"start " + this.hashCode());

		if (bootstrapContext == null) {
			throw new ResourceAdapterInternalException(
					"BootstrapContext can not be null");
		}
		this.bootstrapContext = bootstrapContext;
//		try {
//		
//
////			connectionStateManager = new EJBCActivityConnectionStateManager(
////					bootstrapContext.createTimer(), 1L,
////					((DataSource) new InitialContext()
////							.lookup(MappedNames.ACTIVE_DATASOURCE)));
//
//		} catch (UnavailableException e) {
//			throw new ResourceAdapterInternalException(e);
//		} catch (NamingException e) {
//			throw new ResourceAdapterInternalException("Not found MappedNames.ACTIVE_DATASOURCE: "+MappedNames.ACTIVE_DATASOURCE,e);
//		}

		// this.workManager = bootstrapContext.getWorkManager();

		// try {
		// this.workManager.scheduleWork(new Work() {
		//
		// public void release() {
		// // TODO Auto-generated method stub
		// Logger.getLogger(this.getClass().getName()).info("release");
		//					
		// }
		//
		// public void run() {
		// Logger.getLogger(this.getClass().getName()).info("release");
		// ActivityProcessableRemote activity = null;
		// try {
		// InitialContext ctx = new InitialContext();
		// activity = (ActivityProcessableRemote) ctx
		// .lookup("ejb/sms/active/module/EJBCActivityTest");
		// } catch (NamingException e) {
		// e.printStackTrace();
		// }
		//					
		// }
		//				
		// });
		// } catch (WorkException e1) {
		// e1.printStackTrace();
		// }
		//		

		// activity.doConfig();

		// ejb/sms/active/module/EJBCActivityTest

		// ActivityData cData = ActivityConnectionFactory
		// .getConnectionData(getConnectionData());
		// if (!(cData instanceof JNDIActivityData)) {
		// throw new ResourceAdapterInternalException(ErrorCode.ACT_ERR_0001
		// .getMessage(), ErrorCode.ACT_ERR_0001.name());
		// }
		// Logger.getLogger(this.getClass().getName()).info(
		// "JNDIActivityData OK!");
		//
		// Activity act = new Activity();
		// act.setActCode(getActivityCode());
		// act.setActivityManagers(new ActivityManagers(getManagerID()));
		// act.setActConnectionData(getConnectionData());
		// act.setActStatus(Status.ACTIVE.VISIBLE);
		//		
		//		
		//
		// ActivityProcessableRemote activity = null;
		// try {
		// InitialContext ctx = new InitialContext();
		// activity = (ActivityProcessableRemote) ctx
		// .lookup(((JNDIActivityData) cData).getAddress());
		// } catch (NamingException e) {
		// throw new ResourceAdapterInternalException(ErrorCode.ACT_ERR_0002
		// .getMessage()
		// + " (name: "
		// + ((JNDIActivityData) cData).getAddress()
		// + ")", ErrorCode.ACT_ERR_0002.name());
		// }
		// Logger.getLogger(this.getClass().getName()).info("lookup OK!");

	}

	public void stop() {
		// Logger.getLogger(this.getClass().getSimpleName()).info("stop()");
		Logger.getLogger(this.getClass().getSimpleName()).info(
				"stop() this.hashCode:" + this.hashCode());
//		connectionStateManager.cancel();

	}

	// public int getManagerID() {
	// return managerID;
	// }
	//
	// public void setManagerID(int managerID) {
	// this.managerID = managerID;
	// }
	//
	// public String getActivityCode() {
	// return activityCode;
	// }
	//
	// public void setActivityCode(String code) {
	// this.activityCode = code;
	// }
	//
	// public String getConnectionData() {
	// return connectionData;
	// }
	//
	// public void setConnectionData(String connectionData) {
	// this.connectionData = connectionData;
	// }

	public WorkManager getWorkManager() {
		return workManager;
	}

	private void setWorkManager(WorkManager workManager) {
		this.workManager = workManager;
	}

	public BootstrapContext getBootstrapContext() {
		return bootstrapContext;
	}
}
