/**
 * 
 */
package pl.smi.sms.active.manager;

import javax.ejb.Remote;

/**
 * @author rmalinowski
 *
 */
@Remote
public interface SMSBeanRemote {
 	void onTextMessage(String message) ; 
 	
    /**
     * Wysyla sms
     * @return czy powiodlo sie
     * @param serviceNumber - numer serwisu na ktory wyslany ma byc sms
     * @param phoneNumber - numer telefonu
     * @param text - tekst jaki ma byc wyslany
     * @param operatorId - moze byc nullem
     */
    public boolean sendText(String serviceNumber, String phoneNumber, String text,String operatorId);
    
    /**
     * Wysyla sms
     * @return czy powiodlo sie
     * @param serviceNumber - numer serwisu na ktory wyslany ma byc sms
     * @param phoneNumber - numer telefonu
     * @param text - tekst jaki ma byc wyslany
     * @param operatorId - moze byc nullem
     * @param delay - czas opoznienia jesli null to 0 
     */
    public boolean sendText(String serviceNumber, String phoneNumber, String text,String operatorId,Integer delay);

}
