/**
 * 
 */
package pl.smi.sms.active.helpers;

import java.util.logging.Logger;

import javax.naming.InitialContext;
import javax.naming.NamingException;

import org.junit.Ignore;

import pl.smi.sms.active.manager.SMSBeanRemote;
import pl.smi.sms.active.process.ActivityProcessableRemote;

/**
 * @author rmalinowski
 *
 */
@Ignore
public class TestContextFactory {
    private static final String JDBC_DATASOURCE_NAME = "jdbc/sms/active/DataSource";
    private static final String SMS_MAIN = "ejb/sms/active/SMSMainBean";
    
	
//    public static PrefixServiceRemote getPrefixServiceRemote() {
//        return prefixServiceRemote == null ? prefixServiceRemote = initPrefixServiceRemote() : prefixServiceRemote;
//    }
 
    
    private static SMSBeanRemote initSMSBeanLocal() {
        javax.naming.InitialContext ctx;
        SMSBeanRemote bean;
        try {
            java.util.Properties p = new java.util.Properties();
            p.put("org.omg.CORBA.ORBInitialHost","localhost");
            p.put("org.omg.CORBA.ORBInitialPort","3700");
            ctx = new javax.naming.InitialContext(p);
            // MappedNames.STD_DS+"2" jest dla testow
            System.out.println(SMS_MAIN);
            bean = (SMSBeanRemote) ctx.lookup(SMS_MAIN);     
            
           return bean;
            
        } catch (javax.naming.NamingException ex) {
            ex.printStackTrace();
            throw new RuntimeException(ex);
        }
    }   
       
    public static void main(String...args) {
//    	initConnectionManager();
    	SMSBeanRemote bean = initSMSBeanLocal();
    	
    	InitialContext ctx = null;
		try {
			ctx = new javax.naming.InitialContext();
			Object lookup = ctx.lookup("ejb/sms/active/module/EJBCActivityTest");				
			ActivityProcessableRemote activity = (ActivityProcessableRemote) lookup;
			activity.doInit();
//			activity.doProcess(request, response);
//			activity.doProcess(request, response);
		} catch (NamingException e) {
			e.printStackTrace();
		}
		
		Logger.getLogger(TestContextFactory.class.getName()).info("main");
    	
    	
    	bean.onTextMessage("Test !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"); 
    }
    
//    private static PrefixServiceRemote initPrefixServiceRemote() {
//        javax.naming.InitialContext ctx;
//        PrefixServiceRemote prefixServiceRemote;
//        try {
//            java.util.Properties p = new java.util.Properties();
//            p.put("org.omg.CORBA.ORBInitialHost","jabba");
//            p.put("org.omg.CORBA.ORBInitialPort","3700");
//            ctx = new javax.naming.InitialContext(p);
//            prefixServiceRemote = (PrefixServiceRemote) ctx.lookup(MappedNames.PREFIX_SERVICE_BEAN);     
//            
//            return prefixServiceRemote;
//            
//            
//        } catch (javax.naming.NamingException ex) {
//            ex.printStackTrace();
//            throw new RuntimeException(ex);
//        }
//    }
    
    
    
    
//    public static SMSStdServiceContext getServiceContext() {
//        return serviceContext == null ? serviceContext = new SMSStdServiceContext(getConnectionManager()) : serviceContext;
//    }
}
