package pl.smi.sms.active.module.test;

import java.util.logging.Logger;

import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.ejb.Remote;
import javax.ejb.Stateless;

import pl.smi.sms.active.process.ActivityProcessableRemote;


/**
 * Session Bean implementation class EJBCActivityTest ejb/sms/std/SMSStdBeanImpl
 */
@Stateless(mappedName = "ejb/sms/active/module/EJBCActivityTest")
@Remote({ActivityProcessableRemote.class})
public class EJBCActivityTest implements ActivityProcessableRemote {

	/**
	 * Default constructor.
	 */
	public EJBCActivityTest() {
	}

	@PostConstruct
	public void postConstruct() {
		Logger.getLogger(this.getClass().getName()).info(
				"@PostConstruct called");
	}

	@PreDestroy
	public void preDestroy() {
		Logger.getLogger(this.getClass().getName()).info("@PreDestroy called");
	}

	

	public void doInit() {
		Logger.getLogger(this.getClass().getName()).info(
				"=====" + this.getClass().getClassLoader().hashCode());
		Logger.getLogger(this.getClass().getName()).info("doProcessInit HEJ!");
	}


}
