package pl.smi.sms.active.ra.ejbc;

import java.io.Serializable;

import javax.resource.ResourceException;
import javax.resource.spi.ConnectionManager;

import pl.smi.sms.active.ra.ejbc.cci.EJBCConnection;
import pl.smi.sms.active.ra.ejbc.cci.EJBCConnectionFactory;

public class EJBCConnectionFactoryImpl implements EJBCConnectionFactory , Serializable {

	private final EJBCManagedConnectionFactoryImpl mcf;
	private final ConnectionManager cm;

	public EJBCConnectionFactoryImpl(
			EJBCManagedConnectionFactoryImpl managedConnectionFactoryImpl,
			ConnectionManager connectionManager) {
		this.mcf = managedConnectionFactoryImpl;
		this.cm = connectionManager;

	}

	public EJBCConnection getConnection()
			throws ResourceException {
		
		EJBCConnectionRequestInfoImpl reqInfo = new EJBCConnectionRequestInfoImpl();
		return (EJBCConnection) cm.allocateConnection(mcf, reqInfo);

	}

}
