package pl.smi.sms.active.ra.ejbc;

import javax.ejb.EJBException;

import pl.smi.sms.active.process.ActivityProcessableRemote;
import pl.smi.sms.active.ra.ejbc.cci.EJBCConnection;

public class EJBCConnectionImpl implements EJBCConnection {

	private final ActivityProcessableRemote activity;
//	private final HashSet<ActivityProcessListener> listeners = new HashSet<ActivityProcessListener>();
	private boolean active = true;

	public EJBCConnectionImpl(ActivityProcessableRemote activity) {
		if (activity == null) {
			active = false;
		}

		this.activity = activity;
	}

	public EJBCConnectionImpl(ActivityProcessableRemote activity, boolean active) {
		this.activity = activity;
		this.active = active;
		if (activity == null) {
			active = false;
		}
	}

	/**
	 * On exception notify listeners onFailure
	 * before call check isActive, if not NullPointerException will throw
	 */
//	public void doProcess(ActivityRequest request, ActivityResponse response) {
//		try {
//			if (active)
//			activity.doProcess(request, response);
//		} catch (Exception ex) {
//			EJBCCallExceptionHandler.logException(ex, "doProcess",
//					EJBCConnectionImpl.class.getName());
//			notifyListenersOnProcessFailure(request);
//		}
//	}

	/**
	 * @throws EJBException
	 */
	public void doInit() {
		if (active)
		activity.doInit();
	}

	/**
	 * @throws EJBException
	 */
//	public ActivityConfiguration doConfig() {
//		
//		return activity.doConfig();
//	}

//	public void addActivityProcessListener(ActivityProcessListener listener) {
//		listeners.add(listener);
//	}
//
//	public void removeActivityProcessListener(ActivityProcessListener listener) {
//		listeners.remove(listener);
//	}

//	private void notifyListenersOnProcessFailure(ActivityRequest request) {
//		for (Iterator iterator = listeners.iterator(); iterator.hasNext();) {
//			ActivityProcessListener listener = (ActivityProcessListener) iterator
//					.next();
//			listener.onProcessFailure(this, request);
//		}
//	}

	public boolean isActive() {
		return active;
	}

	public void setActive(boolean active) {
		this.active = active;
	}
}
